PROGRAM polytest
! Test of polynomial sum
  USE polynom
  USE rationalpolynom

  IMPLICIT NONE
  TYPE(poly),    DIMENSION(6)              :: p1
  TYPE(poly),    DIMENSION(4)              :: p2
  TYPE(poly)                               :: ps
  TYPE(poly),    DIMENSION(:), ALLOCATABLE :: res

  TYPE(ratpoly)                            :: rp1
  TYPE(ratpoly)                            :: rp2
  TYPE(ratpoly)                            :: rre

  INTEGER                                  :: i

  ps%c = 7
  p1%c = (/ (i, i=1,SIZE(p1)) /)
  p2%c = (/ (i+3, i=1,SIZE(p2)) /)

  PRINT *, 'Sum of polynomials'
  PRINT *, ' ' 

  ALLOCATE( res(SIZE(p1)) )

  res = p1 + ps
  PRINT *, 'p1  = ',p1%c 
  PRINT *, 'ps  = ',ps%c 
  PRINT *, 'res = ',res%c
  PRINT *, ' ' 

  res = ps + p1
  PRINT *, 'p1  = ',p1%c 
  PRINT *, 'ps  = ',ps%c 
  PRINT *, 'res = ',res%c 
  PRINT *, ' ' 

  res = p1 + p2
  PRINT *, 'p1  = ',p1%c 
  PRINT *, 'p2  = ',p2%c 
  PRINT *, 'res = ',res%c 
  PRINT *, ' ' 

  res = p2 + p1
  PRINT *, 'p1  = ',p1%c 
  PRINT *, 'p2  = ',p2%c 
  PRINT *, 'res = ',res%c 
  PRINT *, ' ' 

  DEALLOCATE(res)

  PRINT *, 'Sum of polynomials'
  PRINT *, ' ' 

  rp1%n = 1
  rp1%d = 2
  rp2%n = 1
  rp2%d = 3

  rre = rp1 + rp2

  PRINT *, 'rp1: ',rp1%n,'/',rp1%d
  PRINT *, 'rp2: ',rp2%n,'/',rp2%d
  PRINT *, 'rre: ',rre%n,'/',rre%d
  PRINT *, ' ' 

END PROGRAM polytest

